
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "QmfPackage.h"
#include <qmf/Schema.h>
#include <qmf/SchemaProperty.h>
#include <qmf/SchemaMethod.h>
#include <string>

using namespace std;
using namespace qmf::org::matahariproject;

void PackageDefinition::configure(::qmf::AgentSession& session)
{
    string package("org.matahariproject");

    //
    // Data: Host
    //
    data_Host = qmf::Schema(SCHEMA_TYPE_DATA, package, "Host");
    {
        qmf::SchemaProperty prop("uuid", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setIndex(true);
        prop.setDesc("Host UUID");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("hostname", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setIndex(true);
        prop.setDesc("Hostname");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("hardware_uuid", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("Host Hardware UUID");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("os", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("The installed operating system.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("arch", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("The host's architecture");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("wordsize", qmf::SCHEMA_DATA_INT);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setUnit("bit");
        prop.setDesc("The wordsize for the host");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("memory", qmf::SCHEMA_DATA_INT);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setUnit("kb");
        prop.setDesc("Amount of primary memory for host");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("swap", qmf::SCHEMA_DATA_INT);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setUnit("kb");
        prop.setDesc("Amount of swap for host");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("cpu_count", qmf::SCHEMA_DATA_INT);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("The number of physical CPUs.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("cpu_cores", qmf::SCHEMA_DATA_INT);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("The total number of processor cores.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("cpu_model", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("The processor(s) model description.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("cpu_flags", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("The processor(s) CPU flags.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("update_interval", qmf::SCHEMA_DATA_INT);
        prop.setAccess(qmf::ACCESS_READ_WRITE);
        prop.setUnit("s");
        prop.setDesc("The interval at which the host sends out heartbeats and refreshes statistics.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("last_updated", qmf::SCHEMA_DATA_INT);
        prop.setSubtype("abstime");
        prop.setDesc("The last time a heartbeat occurred.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("sequence", qmf::SCHEMA_DATA_INT);
        prop.setDesc("The heartbeat sequence number.");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("free_mem", qmf::SCHEMA_DATA_INT);
        prop.setUnit("kb");
        prop.setDesc("Amount of available memory for host");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("free_swap", qmf::SCHEMA_DATA_INT);
        prop.setUnit("kb");
        prop.setDesc("Amount of available swap for host");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("load", qmf::SCHEMA_DATA_MAP);
        prop.setDesc("The one/five/fifteen minute load average");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("process_statistics", qmf::SCHEMA_DATA_MAP);
        prop.setDesc("Number of processes in each possible state");
        data_Host.addProperty(prop);
    }

    {
        qmf::SchemaMethod method("identify");
        method.setDesc("Tells the host to beep its pc speaker.");
        data_Host.addMethod(method);
    }

    {
        qmf::SchemaMethod method("shutdown");
        method.setDesc("Shutdown node");
        data_Host.addMethod(method);
    }

    {
        qmf::SchemaMethod method("reboot");
        method.setDesc("Reboot node");
        data_Host.addMethod(method);
    }

    session.registerSchema(data_Host);

    //
    // Data: Network
    //
    data_Network = qmf::Schema(SCHEMA_TYPE_DATA, package, "Network");
    {
        qmf::SchemaProperty prop("uuid", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("Host UUID");
        data_Network.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("hostname", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setIndex(true);
        prop.setDesc("Hostname");
        data_Network.addProperty(prop);
    }

    {
        qmf::SchemaMethod method("list");
        method.setDesc("List IP addresses");
        {
            qmf::SchemaProperty arg("iface_map", qmf::SCHEMA_DATA_LIST);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Network.addMethod(method);
    }

    {
        qmf::SchemaMethod method("start");
        method.setDesc("Start a network interface");
        {
            qmf::SchemaProperty arg("iface", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("status", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Network.addMethod(method);
    }

    {
        qmf::SchemaMethod method("stop");
        method.setDesc("Stop a network interface");
        {
            qmf::SchemaProperty arg("iface", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("status", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Network.addMethod(method);
    }

    {
        qmf::SchemaMethod method("status");
        method.setDesc("Check a network interface");
        {
            qmf::SchemaProperty arg("iface", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("status", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Network.addMethod(method);
    }

    {
        qmf::SchemaMethod method("get_ip_address");
        method.setDesc("Obtain ip addressof a network interface");
        {
            qmf::SchemaProperty arg("iface", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("ip", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Network.addMethod(method);
    }

    {
        qmf::SchemaMethod method("get_mac_address");
        method.setDesc("Obtain mac address of network interface");
        {
            qmf::SchemaProperty arg("iface", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("mac", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Network.addMethod(method);
    }

    session.registerSchema(data_Network);

    //
    // Data: Services
    //
    data_Services = qmf::Schema(SCHEMA_TYPE_DATA, package, "Services");
    {
        qmf::SchemaProperty prop("uuid", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("Host UUID");
        data_Services.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("hostname", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setIndex(true);
        prop.setDesc("Hostname");
        data_Services.addProperty(prop);
    }

    {
        qmf::SchemaMethod method("list");
        method.setDesc("List known system services");
        {
            qmf::SchemaProperty arg("services", qmf::SCHEMA_DATA_LIST);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Services.addMethod(method);
    }

    {
        qmf::SchemaMethod method("enable");
        method.setDesc("Configure a system service to start at boot");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        data_Services.addMethod(method);
    }

    {
        qmf::SchemaMethod method("disable");
        method.setDesc("Configure a system service _not_ to start at boot");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        data_Services.addMethod(method);
    }

    {
        qmf::SchemaMethod method("start");
        method.setDesc("Start a system service");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("timeout", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("rc", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Services.addMethod(method);
    }

    {
        qmf::SchemaMethod method("stop");
        method.setDesc("Stop a system service");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("timeout", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("rc", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Services.addMethod(method);
    }

    {
        qmf::SchemaMethod method("status");
        method.setDesc("Check the health of a system service");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("interval", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("timeout", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("rc", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Services.addMethod(method);
    }

    {
        qmf::SchemaMethod method("cancel");
        method.setDesc("Cancel a pending or running action on a system service");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("action", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("interval", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        data_Services.addMethod(method);
    }

    {
        qmf::SchemaMethod method("fail");
        method.setDesc("Raise a failure event for a system service");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        data_Services.addMethod(method);
    }

    {
        qmf::SchemaMethod method("describe");
        method.setDesc("Obtain XML description of a system service");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("xml", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Services.addMethod(method);
    }

    session.registerSchema(data_Services);

    //
    // Data: Resources
    //
    data_Resources = qmf::Schema(SCHEMA_TYPE_DATA, package, "Resources");
    {
        qmf::SchemaProperty prop("uuid", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setDesc("Host UUID");
        data_Resources.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("hostname", qmf::SCHEMA_DATA_STRING);
        prop.setAccess(qmf::ACCESS_READ_ONLY);
        prop.setIndex(true);
        prop.setDesc("Hostname");
        data_Resources.addProperty(prop);
    }

    {
        qmf::SchemaMethod method("list_classes");
        method.setDesc("List known resource classes (OCF, LSB, Upstart, etc)");
        {
            qmf::SchemaProperty arg("classes", qmf::SCHEMA_DATA_LIST);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Resources.addMethod(method);
    }

    {
        qmf::SchemaMethod method("list_ocf_providers");
        method.setDesc("List known OCF providers (if supported)");
        {
            qmf::SchemaProperty arg("providers", qmf::SCHEMA_DATA_LIST);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Resources.addMethod(method);
    }

    {
        qmf::SchemaMethod method("list");
        method.setDesc("List known resource types for a given provider");
        {
            qmf::SchemaProperty arg("provider", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("types", qmf::SCHEMA_DATA_LIST);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Resources.addMethod(method);
    }

    {
        qmf::SchemaMethod method("describe");
        method.setDesc("Obtain XML description of a resource");
        {
            qmf::SchemaProperty arg("class", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("provider", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("type", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("xml", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Resources.addMethod(method);
    }

    {
        qmf::SchemaMethod method("start");
        method.setDesc("Start a resource");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("class", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("provider", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("type", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("parameters", qmf::SCHEMA_DATA_MAP);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("timeout", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("rc", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Resources.addMethod(method);
    }

    {
        qmf::SchemaMethod method("stop");
        method.setDesc("Stop a resource");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("class", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("provider", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("type", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("parameters", qmf::SCHEMA_DATA_MAP);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("timeout", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("rc", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Resources.addMethod(method);
    }

    {
        qmf::SchemaMethod method("monitor");
        method.setDesc("Check the health of a resource");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("class", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("provider", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("type", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("interval", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("parameters", qmf::SCHEMA_DATA_MAP);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("timeout", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("rc", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Resources.addMethod(method);
    }

    {
        qmf::SchemaMethod method("invoke");
        method.setDesc("Perform a custom action on a resource");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("class", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("provider", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("type", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("action", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("interval", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("parameters", qmf::SCHEMA_DATA_MAP);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("timeout", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("rc", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_OUT);
            method.addArgument(arg);
        }

        data_Resources.addMethod(method);
    }

    {
        qmf::SchemaMethod method("cancel");
        method.setDesc("Cancel a pending or running action on a resource");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("class", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("provider", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("type", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("action", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("interval", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("timeout", qmf::SCHEMA_DATA_INT);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN);
            method.addArgument(arg);
        }

        data_Resources.addMethod(method);
    }

    {
        qmf::SchemaMethod method("fail");
        method.setDesc("Indicate a resource has failed");
        {
            qmf::SchemaProperty arg("name", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("class", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("provider", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        {
            qmf::SchemaProperty arg("type", qmf::SCHEMA_DATA_STRING);
            arg.setDesc("None");
            arg.setDirection(qmf::DIR_IN_OUT);
            method.addArgument(arg);
        }

        data_Resources.addMethod(method);
    }

    session.registerSchema(data_Resources);

    //
    // Event: heartbeat
    //
    event_heartbeat = qmf::Schema(SCHEMA_TYPE_EVENT, package, "heartbeat");
    event_heartbeat.setDefaultSeverity(qmf::SEV_INFORM);
    {
        qmf::SchemaProperty prop("timestamp", qmf::SCHEMA_DATA_INT);
        prop.setSubtype("abstime");
        event_heartbeat.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("sequence", qmf::SCHEMA_DATA_INT);
        event_heartbeat.addProperty(prop);
    }

    session.registerSchema(event_heartbeat);

    //
    // Event: service_op
    //
    event_service_op = qmf::Schema(SCHEMA_TYPE_EVENT, package, "service_op");
    event_service_op.setDefaultSeverity(qmf::SEV_INFORM);
    {
        qmf::SchemaProperty prop("name", qmf::SCHEMA_DATA_STRING);
        event_service_op.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("action", qmf::SCHEMA_DATA_STRING);
        event_service_op.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("interval", qmf::SCHEMA_DATA_INT);
        event_service_op.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("rc", qmf::SCHEMA_DATA_INT);
        event_service_op.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("sequence", qmf::SCHEMA_DATA_INT);
        event_service_op.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("timestamp", qmf::SCHEMA_DATA_INT);
        prop.setSubtype("abstime");
        event_service_op.addProperty(prop);
    }

    session.registerSchema(event_service_op);

    //
    // Event: resource_op
    //
    event_resource_op = qmf::Schema(SCHEMA_TYPE_EVENT, package, "resource_op");
    event_resource_op.setDefaultSeverity(qmf::SEV_INFORM);
    {
        qmf::SchemaProperty prop("name", qmf::SCHEMA_DATA_STRING);
        event_resource_op.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("action", qmf::SCHEMA_DATA_STRING);
        event_resource_op.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("interval", qmf::SCHEMA_DATA_INT);
        event_resource_op.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("rc", qmf::SCHEMA_DATA_INT);
        event_resource_op.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("sequence", qmf::SCHEMA_DATA_INT);
        event_resource_op.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("timestamp", qmf::SCHEMA_DATA_INT);
        prop.setSubtype("abstime");
        event_resource_op.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("rsc_type", qmf::SCHEMA_DATA_STRING);
        event_resource_op.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("rsc_class", qmf::SCHEMA_DATA_STRING);
        event_resource_op.addProperty(prop);
    }

    {
        qmf::SchemaProperty prop("rsc_provider", qmf::SCHEMA_DATA_STRING);
        event_resource_op.addProperty(prop);
    }

    session.registerSchema(event_resource_op);

}

